function getTargetPage() {
	var parts = window.top.location.href.split('#');
	if (parts.length > 1)
		return parts[1];
	else
		return '';
}

var targetPage = getTargetPage();

if (typeof(defaultTopicPage) === 'undefined') {
	defaultTopicPage = 'about.html';
}

function joinPath(a, b) {
	var aParts = a.split('/');
	var bParts = b.split('/');
	
	if (aParts.length > 0) 
		aParts.pop();
		
	for (var i = 0; i < bParts.length; i++) {
		if (bParts[i] == '..')
			aParts.pop();
		else
			aParts.push(bParts[i]);
	}
	
	return aParts.join('/');
}

function handleMessage(e) {
	var currentPath;
	var hash;	
	if (e.data.path) {
		currentPath = e.data.path;
		hash = '#' + e.data.path;
	} else if (e.data.relativePath) {
		currentPath = window.top.location.hash;
		if (currentPath && currentPath.charAt(0) == '#')
			currentPath = currentPath.substring(1);
			
		if (currentPath) {
			currentPath = joinPath(currentPath, e.data.relativePath);
			hash = '#' + currentPath;
		} else {
			currentPath = e.data.relativePath;
			hash = '#' + currentPath;
		}
	}
	
	var title = e.data.title || '';
	
	if (window.top.history)
		window.top.history.pushState('', title, hash);
	else
		window.top.location.hash = hash;
	
	window.top.topic.location.replace(currentPath);
	
	if (e.data.relativePath && window.toc)
		window.toc.postMessage({'path' : currentPath}, '*');
}

if (window.attachEvent)
	window.attachEvent('message', handleMessage);
else
	window.addEventListener('message', handleMessage, false);
	
if ('onhashchange' in window) {
	window.addEventListener('hashchange', function() {
		var currentPath = window.top.location.hash;
		if (currentPath && currentPath.charAt(0) == '#')
			currentPath = currentPath.substring(1);
		
		if (!currentPath)
			currentPath = defaultTopicPage || targetPage;
		
		window.top.topic.location.replace(currentPath);
		
		if (window.toc)
			window.toc.postMessage({'path' : currentPath}, '*');
	}, false);		
}

$(document).ready(function() {
	if (targetPage != '') {
		window.top.topic.location.replace(targetPage);
	}
	
	if (window.toc) {
		setTimeout(function() {
			window.toc.postMessage({'path' : targetPage || defaultTopicPage}, '*');
		}, 300);			
	}
});